<template>
  <div class="ele-body">
    <!-- 表格 -->
    <ele-pro-table
      ref="tableRef"
      row-key="warehouseId"
      :columns="columns"
      :datasource="datasource"
      v-model:selection="selection"
      tool-class="ele-toolbar-form"
      :scroll="{ x: 800 }"
      class="sys-org-table"
    >
      <template #toolbar>
        <search
          @search="reload"
          :selection="selection"
          @add="openEdit"
          @remove="removeBatch"
          @batchMove="openMove"
        />
      </template>
      <template #bodyCell="{ column, record }">
        <template v-if="column.key === 'warehouseName'">
          <a-tooltip title="查看详情">
            <a href="#" @click="openEdit(record)">{{ record.warehouseName }}</a>
          </a-tooltip>
        </template>
        <template v-if="column.key === 'status'">
          <a-tag v-if="record.status === 0" color="green">正常</a-tag>
          <a-tag v-if="record.status === 1" color="red">待审核</a-tag>
          <a-tag v-if="record.status === 2" color="purple">已驳回</a-tag>
        </template>
        <template v-if="column.key === 'region'">
          <a-tooltip
            :title="`${record.province} ${record.city} ${record.region}`"
          >
            <span>{{ `${record.city}${record.region}` }}</span>
          </a-tooltip>
        </template>
        <template v-if="column.key === 'createTime'">
          <a-tooltip :title="`${toDateString(record.createTime)}`">
            {{ timeAgo(record.createTime) }}
          </a-tooltip>
        </template>
        <template v-if="column.key === 'action'">
          <a-space>
            <a @click="openEdit(record)">修改</a>
            <a-divider type="vertical" />
            <a-popconfirm
              title="确定要删除此记录吗？"
              @confirm="remove(record)"
            >
              <a class="ele-text-danger">删除</a>
            </a-popconfirm>
          </a-space>
        </template>
      </template>
    </ele-pro-table>
    <!-- 编辑弹窗 -->
    <WarehouseEdit v-model:visible="showEdit" :data="current" @done="reload" />
  </div>
</template>

<script lang="ts" setup>
  import { computed, createVNode, ref } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import { toDateString } from 'ele-admin-pro';
  import Search from './components/search.vue';
  import WarehouseEdit from './components/warehouse-edit.vue';
  import {
    pageWarehouse,
    removeWarehouse,
    removeBatchWarehouse
  } from '@/api/tower/warehouse';
  import { timeAgo } from 'ele-admin-pro';
  import type { Warehouse, WarehouseParam } from '@/api/tower/warehouse/model';
  import { useUserStore } from '@/store/modules/user';

  // 当前用户信息
  const userStore = useUserStore();
  const loginUser = computed(() => userStore.info ?? {});

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格选中数据
  const selection = ref<Warehouse[]>([]);
  // 当前编辑数据
  const current = ref<Warehouse | null>(null);
  // 是否显示资产详情
  const showInfo = ref(false);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    if (filters) {
      where.status = filters.status;
    }
    return pageWarehouse({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      key: 'index',
      width: 48,
      align: 'center',
      fixed: 'left',
      hideInSetting: true,
      customRender: ({ index }) => index + (tableRef.value?.tableIndex ?? 0)
    },
    {
      title: '仓库名称',
      dataIndex: 'warehouseName',
      key: 'warehouseName',
      ellipsis: true
    },
    {
      title: '仓库负责人',
      dataIndex: 'warehouseKeeper'
    },
    {
      title: '负责人电话',
      dataIndex: 'warehousePhone'
    },
    {
      title: '所在区域',
      dataIndex: 'region',
      key: 'region'
    },
    {
      title: '仓库地址',
      dataIndex: 'address'
    },
    {
      title: '塔吊数',
      dataIndex: 'tower'
    },
    {
      title: '升降机数',
      dataIndex: 'lift'
    },
    {
      title: '操作',
      key: 'action',
      width: 200,
      align: 'center',
      hideInSetting: true
    }
  ]);

  /* 搜索 */
  const reload = (where?: WarehouseParam) => {
    console.log(where);
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: Warehouse) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  /* 删除单个 */
  const remove = (row: Warehouse) => {
    const hide = message.loading('请求中..', 0);
    removeWarehouse(row.warehouseId)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchWarehouse(
          selection.value.map((d) => {
            if (loginUser.value.userId === d.userId) {
              return d.warehouseId;
            }
          })
        )
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };
</script>

<script lang="ts">
  export default {
    name: 'TowerWarehouse'
  };
</script>

<style lang="less" scoped>
  .sys-org-table :deep(.ant-table-body) {
    overflow: auto !important;
    overflow: overlay !important;
  }

  .sys-org-table :deep(.ant-table-pagination.ant-pagination) {
    padding: 0 4px;
    margin-bottom: 0;
  }
</style>
